package com.faraphel.tasks_valider.connectivity

import android.util.Log
import java.net.InetAddress
import java.net.InetSocketAddress
import java.net.Socket


class DemoClient(hostname: InetAddress, port: Int) {
    companion object {
        var SOCKET_TIMEOUT = 120 * 1000  ///< TEST(Faraphel): long timeout for testing
    }

    private var server = Socket()
    private var address = InetSocketAddress(hostname, port)

    init {
        server.soTimeout = SOCKET_TIMEOUT
    }

    /**
     * Try to contact the server once
     */
    fun once() {
        Log.d("demo-client", "connecting to the server...")
        this.server.connect(this.address, SOCKET_TIMEOUT)
        Log.d("demo-client", "connected !")

        Log.d("demo-client", "sending message...")
        server.getOutputStream().write(42)  // send a byte
        Log.d("demo-client", "message sent !")
    }

    /**
     * Try to contact the server indefinitely
     */
    fun start() {
        Thread {
            while (true) {
                try {
                    this.once()
                } catch (exception: Exception) {
                    Log.w("demo-client", "an error occured: $exception")
                }
                Thread.sleep(1000)
            }
        }.start()
    }
}